#include "cMission.h"

#include "main.h"



cObject* cEmptyMission::init(cWorld* world) {
    world->mBackground = new cDomeBackground;
    
    if (true) {
        world->mTime = 12.00f;
    } else {
        float hour;
        getSystemHour(hour);
        world->mTime = hour;
    }
    
    cObject* player = NULL;
    
    if (true) {
        float pos[3] = { -50, 0, -50 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);

        mech->mPad = new cPad;
        mech->mName = "Alpha";

        mech->mController->mEnabled = false; // Disable Autopilot.
        mech->mRoles |= (1UL<<cObject::RED) | (1UL<<cObject::HUMANPLAYER);
        mech->mEnemies |= (1UL<<cObject::BLUE);
        
        player = mech;
        
        //cController* ai = new cController;
        //ai->newState(cController::TARGET, "Delta");
        //mech->mController = ai;
        
        world->spawnObject(mech);
        
        if (true) {
            
            //mech->mountWeapon((char*)"LTorsor", new cExplosion);
            mech->mountWeapon((char*)"LTorsor", new cPlasmaGun);
            if (true) {
                mech->mountWeapon((char*)"LLoArm",  new cMachineGun);
                //mech->mountWeapon((char*)"LTorsor",  new cMachineGun);
                //mech->mountWeapon((char*)"RTorsor",  new cMachineGun);
                mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            }
            mech->mountWeapon((char*)"RTorsor", new cPlasmaGun);
            //mech->mountWeapon((char*)"RLoArm",  new cHomingMissile);
            //mech->mountWeapon((char*)"RLoArm",  new cRaybeam);
        }
    }
    
    return player;
}


// ------------------------------------------------------------


cObject* cTestMission::init(cWorld* world) {
    world->mBackground = new cDomeBackground;
    
    if (true) {
        world->mTime = 12.00f;
    } else {
        float hour;
        getSystemHour(hour);
        world->mTime = hour;
    }
    
    player = initMechs(world);
    initArchitecture(world);
    initFlora(world);
    return player;
}


void cTestMission::onFrag(cObject* fragged) {
    // Nothing great yet.
    if (fragged == player) {
        printf("You Lost!\n");
        exit(1);
    } else if (fragged == primary) {
        printf("+ Primary target fullfilled.\n");
        printf("You Won!\n");
        //exit(0);
    }
}


cObject* cTestMission::initMechs(cWorld* planet) {
    srand(0);
    cObject* player = NULL;
    
    if (true) {
        float pos[3] = { -20, 0, -50 };
        float rot[3] = { 0, -170, 0 };
        cMech* mech = new cMech(pos, rot);
        assert(mech != NULL);
        player = mech;

        mech->mPad = new cPad;
        mech->mName = "Alpha";
        mech->mController->mEnabled = false; // Disable Autopilot.
        mech->mRoles |= 1*(1UL<<cObject::RED) | (1UL<<cObject::HUMANPLAYER);
        mech->mEnemies |= (1UL<<cObject::BLUE);
        
        planet->spawnObject(mech);
        
        if (true) {
            if (!true) mech->mountWeapon((char*)"LTorsor", new cExplosion);
            if (true) {
                mech->mountWeapon((char*)"LTorsor",  new cMachineGun);
                mech->mountWeapon((char*)"RTorsor",  new cMachineGun);
            }
            if (!true) {
                mech->mountWeapon((char*)"LTorsor", new cPlasmaGun);
                mech->mountWeapon((char*)"RTorsor", new cPlasmaGun);
            }
            if (!true) {
                mech->mountWeapon((char*)"LLoArm",  new cMachineGun);
                mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            }
            if (!true) {
                mech->mountWeapon((char*)"RLoArm",  new cHomingMissile);
                mech->mountWeapon((char*)"RLoArm",  new cRaybeam);
            }
        }
    }
    
    
    if (true) {
        float pos[3] = { -5, 0, -50 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = "Bravo";
        
        mech->mRoles |= (1UL<<cObject::RED);
        mech->mEnemies |= (1UL<<cObject::BLUE);
        
        planet->spawnObject(mech);
        
        if (true) {
            //mech->mountWeapon((char*)"LLoArm",  new cMachineGun);
            //mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            mech->mountWeapon((char*)"RTorsor",  new cHomingMissile);
            mech->mountWeapon((char*)"LTorsor",  new cHomingMissile);
        }
        
        //ai->newState(cControllerI::TARGET, "Charly");
        //ai->newState(cController::ROUTE, "Attackroute");
        //mech->mController->newInstruction(cController::FOLLOW, player->mSerial);
        float d[] = { +100, 0, -50 };
        mech->mController->newInstruction(cController::GOTO, 0, d);
        float c[] = { +100, 0, +120 };
        mech->mController->newInstruction(cController::GOTO, 0, c);
        float b[] = { -20, 0, +120 };
        mech->mController->newInstruction(cController::GOTO, 0, b);
        float a[] = { -15, 0, -50 };
        mech->mController->newInstruction(cController::GOTO, 0, a);
        mech->mController->newInstruction(cController::REPEAT, 0, NULL, 4);
    }
    
    
#if 0
    for (int i = 0; i < 1; i++) {
        float pos[3] = { (i%6) * 10 - 50, 0, 20 + (i/6)*10 + (i/6%2)*5 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = "X";
        mech->mRoles |= (1UL<<cObject::BLUE);
        mech->mEnemies |= (1UL<<cObject::RED);

        planet->spawnObject(mech);
        
        if (true) {
            mech->mountWeapon((char*)"LLoArm",  new cMachineGun);
            mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            mech->mountWeapon((char*)"RTorsor",  new cMachineGun);
            mech->mountWeapon((char*)"LTorsor",  new cMachineGun);
        }
    }

    for (int i = 0; i < 10; i++) {
        float pos[3] = { (i%6) * 10 - 50, 0, -20 + (i/6)*10 + (i/6%2)*5 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = "Y";
        mech->mRoles |= (1UL<<cObject::RED);
        mech->mEnemies |= (1UL<<cObject::BLUE);

        planet->spawnObject(mech);
        
        if (true) {
            mech->mountWeapon((char*)"LLoArm",  new cSparkGun);
            mech->mountWeapon((char*)"RLoArm",  new cSparkGun);
            mech->mountWeapon((char*)"RTorsor",  new cSparkGun);
            mech->mountWeapon((char*)"LTorsor",  new cRaybeam);
        }
    }
#endif
    
    
    if (true) {
        float pos[3] = { +50, 0, +50 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = "Charly";
        
        mech->mRoles |= (1UL<<cObject::BLUE);
        mech->mEnemies |= (1UL<<cObject::RED);

        //ai->newState(cController::WAIT, (char*) NULL);
        //ai->newState(cController::TARGET, "Delta");
        //ai->newState(cController::ROUTE, "Attackroute");
        
        primary = mech;
        
        planet->spawnObject(mech);
        
        if (true) {
            //mech->mountWeapon((char*)"LTorsor", new cExplosion);
            mech->mountWeapon((char*)"LLoArm",  new cSparkGun);
            mech->mountWeapon((char*)"RLoArm",  new cSparkGun);
            //mech->mountWeapon((char*)"RTorsor",  new cHomingMissile);
        }
    }
    
    
    if (true) {
        float pos[3] = { -50, 0, +50 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = "Delta";

        mech->mRoles |= (1UL<<cObject::BLUE);
        mech->mEnemies |= (1UL<<cObject::RED);
        
        //ai->newState(cController::ENGAGE, "Charly");
        //ai->newState(cController::ROUTE, navs);
        
        //gCameraEntity = mech;
        planet->spawnObject(mech);
        
        if (true) {
            mech->mountWeapon((char*)"LLoArm",  new cSparkGun);
            //mech->mountWeapon((char*)"LLoArm",  new cRaybeam);
            //mech->mountWeapon((char*)"RLoArm",  new cRaybeam);
            //mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            //mech->mountWeapon((char*)"RTorsor",  new cHomingMissile);
        }
    }
    
    return player;
}


void cTestMission::initArchitecture(cWorld* planet) {
    srand(0);

    const int b = 0;
    const int width = 11;
    const int height = 11;
    int buildings[][width] = {
        { b, b, b, b, b, b, b, b, b, b, b },
        { b, 4, 4, 0, 6, 6, 0, 3, 4, 3, b },
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, b },
        { b, 3, 3, 0, 5,12, 0, 4, 6, 6, b },
        { b, 4, 6, 0, 8,10, 0, 4,11,11, b },
        { b, 6, 4, 0, 0, 0, 0, 0, 0, 0, b },
        { b, 3, 3, 0,11, 9, 0, 7, 5, 3, b },
        { b, 0, 0, 0, 0, 0, 0, 0, 0, 0, b },
        { b, 6, 6, 0, 5, 5, 0, 9, 4, 3, b },
        { b, 6, 6, 0, 5, 5, 0, 7, 6, 3, b },
        { b, b, b, b, b, b, b, b, b, b, b },
    };

    int roads[][width] = {
        { 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0 },
        { 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0 },
        { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
        { 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1 },
        { 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1 },
        { 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1 },
        { 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1 },
        { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
        { 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1 },
        { 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1 },
        { 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1 },
    };

    // Ground-Tiles
    for (int i = 0; i < width; i++) {
        for (int j = 0; j < height; j++) {
            int center = roads[i][j];
            int east = (i==0) ? 0 : roads[(i+width-1)%width][j];
            int west = ((i+1)==width) ? 0 : roads[(i+1)%width][j];
            int north = (j==0) ? 0 : roads[i][(j+height-1)%height];
            int south = ((j+1)==height) ? 0 : roads[i][(j+1)%height];

            if (center == 1) {
                if (east == 1 && west == 1 && north == 1 && south == 1) {
                    planet->spawnObject(new cTile(i,0,j, cTile::KIND_ROAD_JUNKTION));
                } else if (west == 1 || east == 1) {
                    planet->spawnObject(new cTile(i,0,j, cTile::KIND_ROAD_EASTWEST));
                } else if (south == 1 || north == 1) {
                    planet->spawnObject(new cTile(i,0,j, cTile::KIND_ROAD_NORTHSOUTH));
                }
                
            } else {
                //planet->spawnObject(new cTile(i,0,j, cTile::KIND_CONCRETE));
            }
        }
    }

    // Stacked House-Tiles
    for (int i = 0; i < width; i++) {
        for (int j = 0; j < height; j++) {
            int h_ = buildings[i][j] / 100;
            int h = buildings[i][j] % 100;
            if (h > 0) {
                // Determine width of chunk.
                int a = i;
                while ((buildings[a][j] % 100) >= h && a < width) { a++; }
                a--;
                
                // Determine height of chunk.
                int b = j+1;
                while (b < height) {
                    int t;
                    for (t = i; (t <= a) && ((buildings[t][b] % 100) >= h ); t++);
                    if (t <= a) break;
                    b++;
                }
                b--;
                /*
                int b = j;
                while ((buildings[a][b] % 100) >= h && b < height) { b++; }
                b--;
                 */
                printf("building at: %i %i %i - %i %i %i\n", i, h_, j, a, h, b );
                for (int x = i; x <= a; x++) {
                    for (int y = j; y <= b; y++) {
                        //buildings[x][y] -= h;
                        int old = buildings[x][y];
                        buildings[x][y] += h * 100 - h;
                        while (buildings[x][y] < 0) buildings[x][y] += 1;
                        //printf("%i => %i %i\n", old, buildings[x][y], old + h*100 -h);
                    }
                }
                planet->spawnObject(new cBuilding(i*3,h_,j*3, (a-i+1)*3, h, (b-j+1)*3));
            }
        }
    }
    
    if (!true) {
        planet->spawnObject(new cBuilding(-6,0,0, 5, 4, 8));
    }
    
    
    if (!true) {
        int x = 35;
        int z = 40;
        int n = 10;
        for (int i = 0; i < n; i++) {
            planet->spawnObject(new cBuilding(i+x,i,i+z, 22-2*i, 1, 22-2*i));
        }
    }
    
}


void cTestMission::initFlora(cWorld* planet) {
    srand(0);
       
    struct plantplan {
        int n, seed, type, age;
    } pp[] = {
        {   9, 1234, 0, 3 },
        {   8, 1234, 1, 2 },
        {   4, 1234, 2, 3 },
        {   2, 1234, 0, 4 },
        {   1, 1234, 1, 5 },
    };
    
    int dist = 320;

    for (int j = 0; j < sizeof(pp)/sizeof(plantplan); j++) {
        for (int i=0; i<pp[j].n; i++) {
            float a = rand()%360;
            float b = rand() % (2*dist);
            float pos[3] = { sin(a*0.017454)*b, 0, cos(a*0.017454)*b };
            float rot[3] = { 0, 10*(rand()%36), 0 };
            planet->spawnObject(new cTree(pos, rot, pp[j].seed, pp[j].type, pp[j].age));
        };        
    }
    
}


